on startMovie
  global MemoryTesting, Game, time
  GameStart(MemoryTesting)
  preloadMember(78, 80)
  if MemoryTesting = 0 then
    set MemoryTesting to 0.10000000000000001
  end if
  put " " into field "Question"
  set Game to 0
  BHide(26, 27)
  BoxHide(28, 30)
end

on OrderWords
  global NumberOfWords, Order
  repeat with count = 1 to NumberOfWords
    put 0 into line count of Order
  end repeat
  repeat with count = 1 to NumberOfWords
    set Temp to random(NumberOfWords)
    repeat while line Temp of Order <> 0
      set Temp to random(NumberOfWords)
    end repeat
    put count into line Temp of Order
  end repeat
end

on StartGame
  global Difficulty, BoxUp, NumberOfWords, NumberOfQuestions, UsedUp, Order, TimeStart, timer, QuestionNum, Score1, Score2, stage, Wrong, NoQuiz
  set Wrong to 0
  cursor(4)
  set BoxUp to 0
  set NumberOfWords to 35
  if Difficulty = 0 then
    set NumberOfQuestions to 6
  end if
  if Difficulty = 1 then
    set NumberOfQuestions to 12
  end if
  if Difficulty = 2 then
    set NumberOfQuestions to 18
  end if
  SetBoxes()
  repeat with count = 1 to NumberOfQuestions
    put "No" into line count of UsedUp
  end repeat
  repeat with count = 23 to 40
    resetField(count, 14, "bold", "Helvetica")
  end repeat
  resetField(6, 48, "Bold", "Helvetica")
  resetField(8, 24, "Bold", "Helvetica")
  resetField(22, 18, "Bold", "Helvetica")
  resetField(36, 14, "Bold", "Helvetica")
  OrderWords()
  set Counter to 0
  set QuestionNum to 0
  set Score1 to 0
  set Score2 to 0
  set stage to 0
  set timer to 1
  set TimeStart to the ticks
  set NoQuiz to 1
  cursor(-1)
end

on stop
  global NoQuiz, QuizUp, QuizWaiting
  cursor(4)
  put EMPTY into field 6
  set the puppet of sprite 13 to 0
  set the puppet of sprite 4 to 0
  set the puppet of sprite 5 to 0
  set the keyDownScript to EMPTY
  BSuspend(4, 4)
  BSuspend(6, 7)
  BStop()
  go(2)
  ScoreDisplay()
  set NoQuiz to 0
  if QuizWaiting = 1 then
    PopQuiz()
  end if
  cursor(-1)
end

on Guess1Setup
  global stage, FieldIn
  set FieldIn to 5
  set stage to 1
  go(6)
end

on Guess2Setup
  global stage, Counter
  set Counter to 1
  set stage to 2
  go(8)
  set the puppet of sprite 13 to 1
end

on Compute1
  global Wrong, NumberOfQuestions, QuestionNum, Order, UsedUp, Score1, WhatText, Count2, Total, WordsWrong, AllDone
  BSuspend(4, 4)
  set Temp to 0
  set Total to 0
  set WordsWrong to EMPTY
  repeat with count = 1 to NumberOfQuestions
    set Temp to 0
    set WhatText to "Input" & count
    if the text of cast WhatText <> EMPTY then
      set Total to Total + 1
    else
      set Temp to 2
    end if
    repeat with Count2 = 1 to NumberOfQuestions
      if word 1 of the text of cast WhatText = line the value of line Count2 of Order of the text of cast "Words" then
        set Temp to 1
        if line Count2 of UsedUp = "No" then
          set Score1 to Score1 + 1
        end if
        put "Yes" into line Count2 of UsedUp
      end if
    end repeat
    if Temp = 0 then
      set WordsWrong to WordsWrong & line 1 of the text of cast WhatText & ", "
    end if
  end repeat
  delete char the length of WordsWrong of WordsWrong
  delete char the length of WordsWrong of WordsWrong
  set WordsWrong to WordsWrong & "."
  set Msg to "You entered a total of " & Total & " words and out of those, you got " & Score1 & " right."
  if WordsWrong <> "." then
    set Msg to Msg & " The words you entered that were not shown to you were: " & WordsWrong
  end if
  put Msg into field "MsgBox2"
  cursor(-1)
  ShowBox()
end

on Compute2
  global NumberOfQuestions, QuestionNum, Order, UsedUp, Score2, Counter
  set Temp to 0
  put Counter
  if word 1 of the text of cast "Input" = line the value of line Counter of Order of the text of cast "Words" then
    if line Counter of UsedUp = "No" then
      set Score2 to Score2 + 1
    end if
    put "Yes" into line Counter of UsedUp
    ShowHint()
    exit
  else
    beep()
    WrongAnswer()
  end if
  put "Yes" into line Counter of UsedUp
end

on WrongAnswer
  global Counter, Order
  put "I'm sorry, that is incorrect.  The correct word was " & line the value of line Counter of Order of the text of cast "Words" & "." into field "MsgBox"
  ShowBox()
end

on ShowHint
  global NumberOfQuestions, UsedUp, Order, OldCount, Counter
  put EMPTY into field "Input"
  repeat with Counter = 1 to NumberOfQuestions
    if line Counter of UsedUp = "No" then
      put line the value of line Counter of Order of the text of cast "Hints" into field "HintBox"
      exit
    end if
    if Counter = NumberOfQuestions then
      EndGame()
      exit
    end if
  end repeat
end

on EndGame
  global Score1, Score2, Total, stage
  set stage to 10
  put "You got " & Score1 & " right without hints and got " & Score2 & " right after having hints!  Your score is " & score() & "." into field "MsgBox"
  ShowBox()
end

on score
  global Score1, Score2, Total, stage, MemoryTesting
  set GameScore to (800 * Score1) - (250 * (Total - Score1)) + (500 * Score2)
  if GameScore < 0 then
    set GameScore to 0
  end if
  if GameScore > MemoryTesting then
    set MemoryTesting to GameScore
  end if
  ScoreDisplay()
  return GameScore
end

on PassHandler
  global Counter, UsedUp
  WrongAnswer()
  put "Yes" into line Counter of UsedUp
end

on SetBoxes
  global NumberOfQuestions
  if NumberOfQuestions = 6 then
    set the visible of sprite 26 to 1
    set the visible of sprite 27 to 1
  end if
  if NumberOfQuestions = 12 then
    set the visible of sprite 26 to 0
    set the visible of sprite 27 to 1
  end if
  if NumberOfQuestions = 18 then
    set the visible of sprite 26 to 0
    set the visible of sprite 27 to 0
  end if
end

on Cycle1
  global BoxUp, FieldIn, NumberOfQuestions
  if BoxUp = 0 then
    if (the key = RETURN) or (the key = TAB) then
      if the shiftDown = 0 then
        set FieldIn to FieldIn + 1
        if FieldIn > (NumberOfQuestions + 4) then
          set FieldIn to 5
        end if
        set the editableText of sprite FieldIn to 1
        dontPassEvent()
      else
        set FieldIn to FieldIn - 1
        if FieldIn = 4 then
          set FieldIn to NumberOfQuestions + 4
        end if
        set the editableText of sprite FieldIn to 1
        dontPassEvent()
      end if
    end if
  end if
  if BoxUp = 1 then
    if the key = RETURN then
      ShowBox()
      dontPassEvent()
    end if
  end if
end

on Cycle2
  global BoxUp
  if BoxUp = 0 then
    if (the key = RETURN) or (the key = TAB) then
      Compute2()
      dontPassEvent()
      exit
    end if
  end if
  if BoxUp = 1 then
    if the key = RETURN then
      ShowBox()
      dontPassEvent()
      exit
    end if
  end if
end

on ShowBox
  global AllDone, BoxUp, stage
  if BoxUp = 1 then
    ClearTrackScripts()
    BSuspend(30, 30)
    set BoxUp to 0
    if stage = 10 then
      BoxHide(28, 30)
      stop()
      exit
    end if
    if stage = 2 then
      go("BoxDown")
      set the keyDownScript to "Cycle2"
      ShowHint()
    end if
    if stage = 1 then
      Guess2Setup()
    end if
    continue()
  else
    BoxTrackScripts()
    set BoxUp to 1
    if stage = 1 then
      BoxShow(28, 30)
    else
      go("BoxUp")
    end if
  end if
end

on KeyCheck
  global BoxUp
  if BoxUp = 1 then
    if the key = RETURN then
      ShowBox()
      dontPassEvent()
    end if
  end if
end

on idle
  GameIdle()
end

on ScientistScreen
  cursor(4)
  go(1, the pathName & "TULVIN_S.DIR")
  cursor(4)
end

on HideInfoComplete
  global FieldIn, TempTime
  if (the frame >= 2) and (the frame <= 5) then
    set the timer to TempTime
  end if
  if (the frame >= 8) and (the frame <= 11) then
    set the editableText of sprite 5 to 1
    set the keyDownScript to "Cycle2"
  end if
  if (the frame >= 6) and (the frame <= 7) then
    set the editableText of sprite FieldIn to 1
    set the keyDownScript to "Cycle1"
  end if
end

on ShowInfoPrep
  global FieldIn, TempTime
  if (the frame >= 2) and (the frame <= 5) then
    set TempTime to the timer
  end if
  if (the frame >= 8) and (the frame <= 11) then
    set the editableText of sprite 5 to 0
  end if
  if (the frame >= 6) and (the frame <= 7) then
    set the editableText of sprite FieldIn to 0
  end if
  return 1
end
